---
product: "AG Studio"
title: "Widget Catalogue"
description: "Every Widget available in the Widget selector is grouped here exactly as the selector groups them, with a live example and setup options for each group."
framework: javascript
version: "3.0.0"
related:
    - title: "Widget Basics"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/widgets/"
    - title: "Building Widgets"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/javascript/building-widgets/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Widget Catalogue

Every Widget available in the Widget selector is grouped here exactly as the selector groups them, with a live example and setup options for each group.

See [Widget Basics](https://www.ag-grid.com/studio/archive/3.0.0/javascript/widgets/) for how Widgets are created and resized, and [Building Widgets](https://www.ag-grid.com/studio/archive/3.0.0/javascript/building-widgets/) for configuring a Widget's data and appearance once it is on the layout.

## Column Chart

Column Chart Widgets use vertical bars to compare values across categories.

**Grouped Column Chart** shows adjacent vertical bars for comparing categories or series side by side. It should be used when comparing individual values matters more than showing how they add up.

**Stacked Column Chart** stacks vertical bars to show part-to-whole relationships across categories. It should be used when both a category's total and its composition matter.

**100% Stacked Column Chart** normalises stacked bars to 100% so segments show proportions rather than absolute values. It should be used when comparing composition across categories matters more than comparing totals.

The example below shows all three Column Chart variants plotted against the same categories, making the shift from absolute values to proportions easy to compare.

#### Column Chart

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "column-chart-grouped": {
          type: "column-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Grouped Column Chart",
            },
          },
        },
        "column-chart-stacked": {
          type: "column-chart-stacked",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Stacked Column Chart",
            },
          },
        },
        "column-chart-stacked-100": {
          type: "column-chart-stacked-100",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "100% Stacked Column Chart",
            },
          },
        },
      },
      widgetLayout: {
        "column-chart-grouped": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 16,
        },
        "column-chart-stacked": {
          xTrack: 0,
          yTrack: 16,
          xSpan: 24,
          ySpan: 16,
        },
        "column-chart-stacked-100": {
          xTrack: 0,
          yTrack: 32,
          xSpan: 24,
          ySpan: 16,
        },
      },
      filter: {
        page: [
          {
            field: { id: "medals.total" },
            model: {
              operator: "greaterThan",
              value: 3,
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Column Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/column-chart/typescript/)

## Bar Chart

Bar Chart Widgets use horizontal bars and behave like Column Charts turned on their side, which suits long category labels.

**Grouped Bar Chart** shows adjacent horizontal bars for comparing categories, and works well when category names are long.

**Stacked Bar Chart** stacks horizontal bars to show part-to-whole relationships across categories.

**100% Stacked Bar Chart** normalises stacked horizontal bars to 100% for comparing proportions across categories.

The example below shows the three Bar Chart variants stacked one above the other, plotting the same categories as the Column Chart example.

#### Bar Chart

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "bar-chart-grouped": {
          type: "bar-chart-grouped",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Grouped Bar Chart",
            },
          },
        },
        "bar-chart-stacked": {
          type: "bar-chart-stacked",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Stacked Bar Chart",
            },
          },
        },
        "bar-chart-stacked-100": {
          type: "bar-chart-stacked-100",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "100% Stacked Bar Chart",
            },
          },
        },
      },
      widgetLayout: {
        "bar-chart-grouped": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 16,
        },
        "bar-chart-stacked": {
          xTrack: 0,
          yTrack: 16,
          xSpan: 24,
          ySpan: 16,
        },
        "bar-chart-stacked-100": {
          xTrack: 0,
          yTrack: 32,
          xSpan: 24,
          ySpan: 16,
        },
      },
      filter: {
        page: [
          {
            field: { id: "medals.total" },
            model: {
              operator: "greaterThan",
              value: 3,
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Bar Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/bar-chart/typescript/)

## Line Chart

The Line Chart group holds a single Widget.

**Line Chart** connects data points with a line to show a trend over time or across a continuous dimension. It should be used when the shape of change matters more than any single value.

The example below shows a Line Chart comparing gold, silver and bronze totals across countries.

#### Line Chart

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "line-chart": {
          type: "line-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Line Chart",
            },
          },
        },
      },
      widgetLayout: {
        "line-chart": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 16,
        },
      },
      filter: {
        page: [
          {
            field: { id: "medals.total" },
            model: {
              operator: "greaterThan",
              value: 3,
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Line Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/line-chart/typescript/)

## Area Chart

Area Chart Widgets fill the area beneath a line, emphasising magnitude alongside trend.

**Area Chart** fills the area beneath a line to emphasise the magnitude of a trend over time.

**Stacked Area Chart** stacks filled areas to show cumulative trends and part-to-whole relationships over time.

**100% Stacked Area Chart** normalises stacked areas to 100% to show proportional trends over time.

The example below shows all three Area Chart variants plotted against the same categories.

#### Area Chart

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "area-chart": {
          type: "area-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Area Chart",
            },
          },
        },
        "area-chart-stacked": {
          type: "area-chart-stacked",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Stacked Area Chart",
            },
          },
        },
        "area-chart-stacked-100": {
          type: "area-chart-stacked-100",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "100% Stacked Area Chart",
            },
          },
        },
      },
      widgetLayout: {
        "area-chart": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 16,
        },
        "area-chart-stacked": {
          xTrack: 0,
          yTrack: 16,
          xSpan: 24,
          ySpan: 16,
        },
        "area-chart-stacked-100": {
          xTrack: 0,
          yTrack: 32,
          xSpan: 24,
          ySpan: 16,
        },
      },
      filter: {
        page: [
          {
            field: { id: "medals.total" },
            model: {
              operator: "greaterThan",
              value: 3,
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Area Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/area-chart/typescript/)

## Value

The Value group covers Widgets that spotlight a single aggregated number.

**KPI** displays a single aggregated number prominently. It should be used for totals and headline metrics that need no visual comparison.

**Radial Gauge** shows a value against a defined range on a circular dial. It should be used for progress or target tracking.

**Linear Gauge** shows a value against a range on a horizontal or vertical bar. It should be used for progress or threshold indicators.

The example below shows a KPI alongside both gauge types tracking the same underlying value.

#### Value

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        value: {
          type: "value",
          dataMapping: {
            value: [{ id: "medals.gold", aggregation: "sum" }],
          },
          format: {
            title: {
              enabled: true,
              text: "KPI",
            },
          },
        },
        "radial-gauge": {
          type: "radial-gauge",
          dataMapping: {
            value: [{ id: "medals.gold", aggregation: "sum" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Radial Gauge",
            },
          },
        },
        "linear-gauge": {
          type: "linear-gauge",
          dataMapping: {
            value: [{ id: "medals.gold", aggregation: "sum" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Linear Gauge",
            },
          },
        },
      },
      widgetLayout: {
        value: {
          xTrack: 0,
          yTrack: 0,
          xSpan: 8,
          ySpan: 12,
        },
        "radial-gauge": {
          xTrack: 8,
          yTrack: 0,
          xSpan: 8,
          ySpan: 12,
        },
        "linear-gauge": {
          xTrack: 16,
          yTrack: 0,
          xSpan: 8,
          ySpan: 12,
        },
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Value](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/value/typescript/)

## Scatter Chart

Scatter Chart Widgets plot individual data points across two axes to reveal correlations.

**Scatter Chart** plots dots on two axes to compare grouped data and show correlations.

**Bubble Chart** extends a scatter plot with variable dot sizes, adding a third data dimension.

The example below shows a Scatter Chart above a Bubble Chart using the same two axes, with the Bubble Chart adding size as a third dimension.

#### Scatter Chart

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "scatter-chart": {
          type: "scatter-chart",
          dataMapping: {
            groupByKey: [{ id: "medals.country" }],
            categoryKey: [{ id: "medals.gold", aggregation: "sum" }],
            valueKey: [{ id: "medals.silver", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Scatter Chart",
            },
          },
        },
        "bubble-chart": {
          type: "bubble-chart",
          dataMapping: {
            groupByKey: [{ id: "medals.country" }],
            sizeKey: [{ id: "medals.total", aggregation: "sum" }],
            categoryKey: [{ id: "medals.gold", aggregation: "sum" }],
            valueKey: [{ id: "medals.silver", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Bubble Chart",
            },
          },
        },
      },
      widgetLayout: {
        "scatter-chart": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 16,
        },
        "bubble-chart": {
          xTrack: 0,
          yTrack: 16,
          xSpan: 24,
          ySpan: 16,
        },
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Scatter Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/scatter-chart/typescript/)

## Table

This group holds the two Widgets for displaying data in rows and columns.

**Table** lists rows and columns with sortable and filterable headers. It should be used for row-level exploration of detailed data.

**Pivot Table** groups and pivots data across row and column axes. It should be used for hierarchical drill-down and cross-tabulated summaries.

The example below shows a flat list of rows above a pivoted view of the same data.

#### Table

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        grid: {
          type: "grid",
          dataMapping: {
            cols: [
              { id: "medals.country" },
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
          },
          format: {
            title: {
              enabled: true,
              text: "Table",
            },
          },
        },
        "pivot-grid": {
          type: "pivot-grid",
          dataMapping: {
            rows: [{ id: "medals.country" }],
            columns: [{ id: "medals.year" }],
            values: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
          },
          format: {
            title: {
              enabled: true,
              text: "Pivot Table",
            },
          },
        },
      },
      widgetLayout: {
        grid: {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 16,
        },
        "pivot-grid": {
          xTrack: 0,
          yTrack: 16,
          xSpan: 24,
          ySpan: 16,
        },
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Table](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/table/typescript/)

### Pivot Table Setup

A Pivot Table summarises a measure across a row axis and, optionally, a column axis. Its Setup panel has three data slots:

- **Rows** - grouping fields, outer to inner. Each field adds a level of row grouping.
- **Columns** - optional grouping fields, outer to inner. Adding a field here pivots the Values onto a column axis instead of listing them as flat columns.
- **Values** - one or more measures, aggregated for each row (and, once pivoted, for each row-column cell).

Row groups start expanded when no field is mapped to Columns, and collapsed once one is. Click a row to expand or collapse it; expanding loads its child rows. Column groups always start collapsed - click to expand them.

#### Pivot Table

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      widgets: {
        "sales-pivot": {
          type: "pivot-grid",
          dataMapping: {
            rows: [{ id: "stores.region" }, { id: "products.subcategory" }],
            columns: [{ id: "orders.channel" }],
            values: [{ id: "net_sales" }, { id: "gross_sales" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Net Sales and Gross Sales by Region, Category, and Channel",
            },
          },
          sort: [{ field: { id: "products.subcategory" }, direction: "asc" }],
        },
      },
      widgetLayout: {
        "sales-pivot": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 41 },
      },
      selection: { type: "widget", id: "sales-pivot" },
    },
  ],
  selectedPageId: "a",
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
  panels: {
    edit: {
      right: ["edit"],
    },
  },
  data: getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Pivot Table](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/pivot-table/typescript/)

### Totals

Two independent totals are available on the Pivot Table's Format tab, both off by default:

- **Total Row** - a grand total pinned as the last row, summing every measure across the whole table.
- **Total Columns** - available once a field is mapped to Columns. Adds a column summing each measure across every column member. Set **Placement** to **Beginning** or **End**.

### Empty Cells

A Pivot Table holds a cell for every combination of row and column member, but the data rarely fills all of them. Where a combination has no rows behind it there is nothing to aggregate, so the cell shows `N/A` instead of a number. A cell showing `0` means the opposite: rows exist for that combination, and the measure adds up to zero across them.

Both appear in the medals example at the top of this section. Its data covers Summer and Winter Games in alternating years, and most countries win in one or the other. A country that competes only in summer shows `N/A` across the winter years. A country that won that year but took no gold shows `0` in its Gold column.

## Polar Chart

The Polar Chart group brings together the radar and radial Widgets, which plot values around a circular axis rather than a linear one.

**Radar Line Chart** uses lines on a radar layout to compare multiple variables at once.

**Radar Area Chart** fills the area on a radar layout to emphasise coverage across dimensions.

**Radial Column Chart** arranges bars in a circle. It should be used for cyclical or categorical data.

**Nightingale Chart** uses sectors of varying radius to emphasise differences in value.

**Radial Bar Chart** uses concentric circular bars for compact category comparisons.

The example below shows all five Polar Chart Widgets plotting the same categories, so the different circular layouts can be compared directly.

#### Polar Chart

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "radar-line-chart": {
          type: "radar-line-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Radar Line Chart",
            },
          },
        },
        "radar-area-chart": {
          type: "radar-area-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Radar Area Chart",
            },
          },
        },
        "radial-column-chart": {
          type: "radial-column-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Radial Column Chart",
            },
          },
        },
        "nightingale-chart": {
          type: "nightingale-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Nightingale Chart",
            },
          },
        },
        "radial-bar-chart": {
          type: "radial-bar-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Radial Bar Chart",
            },
          },
        },
      },
      widgetLayout: {
        "radar-line-chart": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 12,
          ySpan: 20,
        },
        "radar-area-chart": {
          xTrack: 12,
          yTrack: 0,
          xSpan: 12,
          ySpan: 20,
        },
        "radial-column-chart": {
          xTrack: 0,
          yTrack: 20,
          xSpan: 12,
          ySpan: 20,
        },
        "radial-bar-chart": {
          xTrack: 12,
          yTrack: 20,
          xSpan: 12,
          ySpan: 20,
        },
        "nightingale-chart": {
          xTrack: 6,
          yTrack: 40,
          xSpan: 12,
          ySpan: 20,
        },
      },
      filter: {
        page: [
          {
            field: { id: "medals.total" },
            model: {
              operator: "greaterThan",
              value: 3,
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Polar Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/polar-chart/typescript/)

## Proportional Chart

Proportional Chart Widgets show how a whole splits into parts.

**Pie Chart** divides a circle into slices to show simple part-to-whole proportions.

**Donut Chart** is a Pie Chart with a hollow centre, leaving room for a central metric or label.

The example below places a Pie Chart beside a Donut Chart splitting the same values, so the hollow centre is the only difference between them.

#### Proportional Chart

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "pie-chart": {
          type: "pie-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Pie Chart",
            },
          },
        },
        "donut-chart": {
          type: "donut-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Donut Chart",
            },
          },
        },
      },
      widgetLayout: {
        "pie-chart": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 12,
          ySpan: 20,
        },
        "donut-chart": {
          xTrack: 12,
          yTrack: 0,
          xSpan: 12,
          ySpan: 20,
        },
      },
      filter: {
        page: [
          {
            field: { id: "medals.total" },
            model: {
              operator: "greaterThan",
              value: 3,
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Proportional Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/proportional-chart/typescript/)

## Progression Chart

Progression Chart Widgets show values narrowing through sequential stages, such as a sales or conversion funnel.

**Funnel Chart** uses a stepped funnel to show conversion rates or sequential process stages.

**Cone Funnel Chart** uses a smooth-tapering funnel for the same kind of conversion or process visualisation.

**Pyramid Chart** uses a triangular layout for hierarchical or tiered data.

The example below places a Funnel beside a Cone Funnel with a Pyramid below them, so the three shapes can be compared directly.

#### Progression Chart

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "funnel-chart": {
          type: "funnel-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [{ id: "medals.gold", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Funnel Chart",
            },
          },
        },
        "cone-funnel-chart": {
          type: "cone-funnel-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [{ id: "medals.gold", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Cone Funnel Chart",
            },
          },
        },
        "pyramid-chart": {
          type: "pyramid-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [{ id: "medals.gold", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Pyramid Chart",
            },
          },
        },
      },
      widgetLayout: {
        "funnel-chart": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 12,
          ySpan: 16,
        },
        "cone-funnel-chart": {
          xTrack: 12,
          yTrack: 0,
          xSpan: 12,
          ySpan: 16,
        },
        "pyramid-chart": {
          xTrack: 6,
          yTrack: 16,
          xSpan: 12,
          ySpan: 16,
        },
      },
      filter: {
        page: [
          {
            field: { id: "medals.total" },
            model: {
              operator: "greaterThan",
              value: 3,
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Progression Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/progression-chart/typescript/)

## Hierarchical Chart

Hierarchical Chart Widgets show nested part-to-whole relationships, sized by value.

**Treemap Chart** nests rectangles to show a hierarchy of part-to-whole proportions, sized by value.

**Sunburst Chart** uses concentric rings to show the same kind of hierarchy, sized by value.

The example below shows the same hierarchy as both a Treemap and a Sunburst, comparing a rectangular layout against a radial one.

#### Hierarchical Chart

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "treemap-chart": {
          type: "treemap-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }, { id: "medals.sport" }],
            valueKey: [{ id: "medals.gold", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Treemap Chart",
            },
          },
        },
        "sunburst-chart": {
          type: "sunburst-chart",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }, { id: "medals.sport" }],
            valueKey: [{ id: "medals.gold", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Sunburst Chart",
            },
          },
        },
      },
      widgetLayout: {
        "treemap-chart": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 16,
        },
        "sunburst-chart": {
          xTrack: 0,
          yTrack: 16,
          xSpan: 24,
          ySpan: 16,
        },
      },
      filter: {
        page: [
          {
            field: { id: "medals.total" },
            model: {
              operator: "greaterThan",
              value: 3,
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Hierarchical Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/hierarchical-chart/typescript/)

### Hierarchical Chart Setup

Both Widgets share the same Setup panel:

- **Hierarchy Levels** - an ordered list of grouping fields, outermost first. Each level nests inside the one before it.
- **Value** - a numeric field that sizes each tile (Treemap) or segment (Sunburst).

The example below shows sales sized by Net Sales and grouped by Region, then Subcategory.

#### Hierarchical Chart Setup

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "a",
      widgets: {
        "sales-treemap": {
          type: "treemap-chart",
          dataMapping: {
            categoryKey: [
              { id: "stores.region" },
              { id: "products.subcategory" },
            ],
            valueKey: [{ id: "net_sales" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Net Sales by Region and Subcategory",
            },
          },
          sort: [{ field: { id: "products.subcategory" }, direction: "asc" }],
        },
      },
      widgetLayout: {
        "sales-treemap": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 32,
        },
      },
      selection: { type: "widget", id: "sales-treemap" },
    },
  ],
  selectedPageId: "a",
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
  panels: {
    edit: {
      right: ["edit"],
    },
  },
  data: getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
```

[Live example: Hierarchical Chart Setup](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/hierarchy-chart/typescript/)

## Static Content

Static Content Widgets add narrative or supporting material to a report and do not require a data input.

**Text** displays rich text content for titles, descriptions, or annotations, written by the report author rather than bound to a data field.

**Image** displays an image from a URL, for logos, backgrounds, or other visual context, and is likewise not bound to a data field.

The example below shows a Text Widget and an Image Widget placed side by side, neither of them mapped to a field.

#### Static Content

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        text: {
          type: "text",
          dataMapping: {},
          format: {
            title: {
              enabled: true,
              text: "Text",
            },
            style: {
              text: "The Text Widget shows static content such as a heading, a note or an explanation. It is not bound to a data field.",
            },
          },
        },
        image: {
          type: "image",
          dataMapping: {},
          format: {
            title: {
              enabled: true,
              text: "Image",
            },
            style: {
              src: "https://www.ag-grid.com/studio/images/ag-studio-logo.svg",
              objectFit: "contain",
            },
          },
        },
      },
      widgetLayout: {
        text: {
          xTrack: 0,
          yTrack: 0,
          xSpan: 12,
          ySpan: 16,
        },
        image: {
          xTrack: 12,
          yTrack: 0,
          xSpan: 12,
          ySpan: 16,
        },
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Static Content](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/static-content/typescript/)

## Filter

Filter Widgets give report viewers on-canvas controls for narrowing down the data, without opening the [Filters](https://www.ag-grid.com/studio/archive/3.0.0/javascript/filters/) panel.

**Button Filter** shows clickable toggle buttons for quick single or multi-value filtering. It should be used when the list of values is short enough to display as buttons.

**List Filter** shows a scrollable list for selecting one or more values from many options. It should be used when there are too many values to show as buttons.

**Date Filter** shows a date picker for filtering by date range or specific dates.

The example below shows all three Filter Widgets alongside a KPI Widget; selecting a value in any Filter updates the KPI, since it is driven by the combined filter selection.

#### Filter

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "button-filter": {
          type: "button-filter",
          dataMapping: {
            value: [{ id: "medals.country" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Button Filter",
            },
          },
        },
        "list-filter": {
          type: "list-filter",
          dataMapping: {
            value: [{ id: "medals.sport" }],
          },
          format: {
            title: {
              enabled: true,
              text: "List Filter",
            },
          },
        },
        "date-filter": {
          type: "date-filter",
          dataMapping: {
            value: [{ id: "medals.date" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Date Filter",
            },
          },
        },
        value: {
          type: "value",
          dataMapping: {
            value: [{ id: "medals.gold", aggregation: "sum" }],
          },
          format: {
            title: {
              enabled: true,
              text: "Total Gold Medals",
            },
          },
        },
      },
      widgetLayout: {
        "button-filter": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 8,
          ySpan: 16,
        },
        "list-filter": {
          xTrack: 8,
          yTrack: 0,
          xSpan: 8,
          ySpan: 16,
        },
        "date-filter": {
          xTrack: 16,
          yTrack: 0,
          xSpan: 8,
          ySpan: 16,
        },
        value: {
          xTrack: 0,
          yTrack: 16,
          xSpan: 24,
          ySpan: 8,
        },
      },
      filter: {
        page: [
          {
            field: { id: "medals.total" },
            model: {
              operator: "greaterThan",
              value: 3,
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Filter](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/filter/typescript/)

## Combo

Combo Chart Widgets pair columns with a line series on the same chart, useful when a report needs to show a trend alongside the values that make it up.

**Grouped Column / Line Chart** shows adjacent columns for direct comparison across categories, with a line overlaid to trace a trend across the same categories.

**Stacked Column / Line Chart** shows stacked columns for part-to-whole comparison across categories, with a line overlaid to trace a trend across the same categories.

The columns of either variant can also be split by a Legend field, giving one column series per value in that field while the line stays a single trend across all of them.

The example below shows both Combo Chart variants plotting the same columns and trend line, so the grouped and stacked layouts can be compared.

#### Combo

```ts
import {
  AgReportState,
  AgStudioApi,
  AgStudioProperties,
  createStudio,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const initialState: AgReportState = {
  pages: [
    {
      id: "page1",
      widgets: {
        "combo-chart-grouped-column-line": {
          type: "combo-chart-grouped-column-line",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            secondaryValueKey: [{ id: "medals.total", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Grouped Column / Line Chart",
            },
          },
        },
        "combo-chart-stacked-column-line": {
          type: "combo-chart-stacked-column-line",
          dataMapping: {
            categoryKey: [{ id: "medals.country" }],
            valueKey: [
              { id: "medals.gold", aggregation: "sum" },
              { id: "medals.silver", aggregation: "sum" },
              { id: "medals.bronze", aggregation: "sum" },
            ],
            secondaryValueKey: [{ id: "medals.total", aggregation: "sum" }],
            tooltipKey: [],
          },
          format: {
            title: {
              enabled: true,
              text: "Stacked Column / Line Chart",
            },
          },
        },
      },
      widgetLayout: {
        "combo-chart-grouped-column-line": {
          xTrack: 0,
          yTrack: 0,
          xSpan: 24,
          ySpan: 16,
        },
        "combo-chart-stacked-column-line": {
          xTrack: 0,
          yTrack: 16,
          xSpan: 24,
          ySpan: 16,
        },
      },
      filter: {
        page: [
          {
            field: { id: "medals.total" },
            model: {
              operator: "greaterThan",
              value: 3,
            },
          },
        ],
      },
    },
  ],
  selectedPageId: "page1",
  panels: {
    filters: {
      collapsed: true,
    },
    data: {
      collapsed: true,
    },
  },
};

const studioProperties: AgStudioProperties = {
  mode: "edit",
  initialState,
};

let studioApi: AgStudioApi;

// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data) =>
    studioApi!.setProperty("data", { sources: [{ id: "medals", data }] }),
  );
```

[Live example: Combo](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/combo/typescript/)


---
product: "AG Studio"
title: "Widget Catalogue"
description: "Every Widget available in the Widget selector is grouped here exactly as the selector groups them, with a live example and setup options for each group."
framework: angular
version: "3.0.0"
related:
    - title: "Widget Basics"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/widgets/"
    - title: "Building Widgets"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/building-widgets/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Widget Catalogue

Every Widget available in the Widget selector is grouped here exactly as the selector groups them, with a live example and setup options for each group.

See [Widget Basics](https://www.ag-grid.com/studio/archive/3.0.0/angular/widgets/) for how Widgets are created and resized, and [Building Widgets](https://www.ag-grid.com/studio/archive/3.0.0/angular/building-widgets/) for configuring a Widget's data and appearance once it is on the layout.

## Column Chart

Column Chart Widgets use vertical bars to compare values across categories.

**Grouped Column Chart** shows adjacent vertical bars for comparing categories or series side by side. It should be used when comparing individual values matters more than showing how they add up.

**Stacked Column Chart** stacks vertical bars to show part-to-whole relationships across categories. It should be used when both a category's total and its composition matter.

**100% Stacked Column Chart** normalises stacked bars to 100% so segments show proportions rather than absolute values. It should be used when comparing composition across categories matters more than comparing totals.

The example below shows all three Column Chart variants plotted against the same categories, making the shift from absolute values to proportions easy to compare.

#### Column Chart

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Column Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/column-chart/angular/)

## Bar Chart

Bar Chart Widgets use horizontal bars and behave like Column Charts turned on their side, which suits long category labels.

**Grouped Bar Chart** shows adjacent horizontal bars for comparing categories, and works well when category names are long.

**Stacked Bar Chart** stacks horizontal bars to show part-to-whole relationships across categories.

**100% Stacked Bar Chart** normalises stacked horizontal bars to 100% for comparing proportions across categories.

The example below shows the three Bar Chart variants stacked one above the other, plotting the same categories as the Column Chart example.

#### Bar Chart

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Bar Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/bar-chart/angular/)

## Line Chart

The Line Chart group holds a single Widget.

**Line Chart** connects data points with a line to show a trend over time or across a continuous dimension. It should be used when the shape of change matters more than any single value.

The example below shows a Line Chart comparing gold, silver and bronze totals across countries.

#### Line Chart

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Line Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/line-chart/angular/)

## Area Chart

Area Chart Widgets fill the area beneath a line, emphasising magnitude alongside trend.

**Area Chart** fills the area beneath a line to emphasise the magnitude of a trend over time.

**Stacked Area Chart** stacks filled areas to show cumulative trends and part-to-whole relationships over time.

**100% Stacked Area Chart** normalises stacked areas to 100% to show proportional trends over time.

The example below shows all three Area Chart variants plotted against the same categories.

#### Area Chart

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Area Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/area-chart/angular/)

## Value

The Value group covers Widgets that spotlight a single aggregated number.

**KPI** displays a single aggregated number prominently. It should be used for totals and headline metrics that need no visual comparison.

**Radial Gauge** shows a value against a defined range on a circular dial. It should be used for progress or target tracking.

**Linear Gauge** shows a value against a range on a horizontal or vertical bar. It should be used for progress or threshold indicators.

The example below shows a KPI alongside both gauge types tracking the same underlying value.

#### Value

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Value](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/value/angular/)

## Scatter Chart

Scatter Chart Widgets plot individual data points across two axes to reveal correlations.

**Scatter Chart** plots dots on two axes to compare grouped data and show correlations.

**Bubble Chart** extends a scatter plot with variable dot sizes, adding a third data dimension.

The example below shows a Scatter Chart above a Bubble Chart using the same two axes, with the Bubble Chart adding size as a third dimension.

#### Scatter Chart

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Scatter Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/scatter-chart/angular/)

## Table

This group holds the two Widgets for displaying data in rows and columns.

**Table** lists rows and columns with sortable and filterable headers. It should be used for row-level exploration of detailed data.

**Pivot Table** groups and pivots data across row and column axes. It should be used for hierarchical drill-down and cross-tabulated summaries.

The example below shows a flat list of rows above a pivoted view of the same data.

#### Table

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Table](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/table/angular/)

### Pivot Table Setup

A Pivot Table summarises a measure across a row axis and, optionally, a column axis. Its Setup panel has three data slots:

- **Rows** - grouping fields, outer to inner. Each field adds a level of row grouping.
- **Columns** - optional grouping fields, outer to inner. Adding a field here pivots the Values onto a column axis instead of listing them as flat columns.
- **Values** - one or more measures, aggregated for each row (and, once pivoted, for each row-column cell).

Row groups start expanded when no field is mapped to Columns, and collapsed once one is. Click a row to expand or collapse it; expanding loads its child rows. Column groups always start collapsed - click to expand them.

#### Pivot Table

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Pivot Table](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/pivot-table/angular/)

### Totals

Two independent totals are available on the Pivot Table's Format tab, both off by default:

- **Total Row** - a grand total pinned as the last row, summing every measure across the whole table.
- **Total Columns** - available once a field is mapped to Columns. Adds a column summing each measure across every column member. Set **Placement** to **Beginning** or **End**.

### Empty Cells

A Pivot Table holds a cell for every combination of row and column member, but the data rarely fills all of them. Where a combination has no rows behind it there is nothing to aggregate, so the cell shows `N/A` instead of a number. A cell showing `0` means the opposite: rows exist for that combination, and the measure adds up to zero across them.

Both appear in the medals example at the top of this section. Its data covers Summer and Winter Games in alternating years, and most countries win in one or the other. A country that competes only in summer shows `N/A` across the winter years. A country that won that year but took no gold shows `0` in its Gold column.

## Polar Chart

The Polar Chart group brings together the radar and radial Widgets, which plot values around a circular axis rather than a linear one.

**Radar Line Chart** uses lines on a radar layout to compare multiple variables at once.

**Radar Area Chart** fills the area on a radar layout to emphasise coverage across dimensions.

**Radial Column Chart** arranges bars in a circle. It should be used for cyclical or categorical data.

**Nightingale Chart** uses sectors of varying radius to emphasise differences in value.

**Radial Bar Chart** uses concentric circular bars for compact category comparisons.

The example below shows all five Polar Chart Widgets plotting the same categories, so the different circular layouts can be compared directly.

#### Polar Chart

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Polar Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/polar-chart/angular/)

## Proportional Chart

Proportional Chart Widgets show how a whole splits into parts.

**Pie Chart** divides a circle into slices to show simple part-to-whole proportions.

**Donut Chart** is a Pie Chart with a hollow centre, leaving room for a central metric or label.

The example below places a Pie Chart beside a Donut Chart splitting the same values, so the hollow centre is the only difference between them.

#### Proportional Chart

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Proportional Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/proportional-chart/angular/)

## Progression Chart

Progression Chart Widgets show values narrowing through sequential stages, such as a sales or conversion funnel.

**Funnel Chart** uses a stepped funnel to show conversion rates or sequential process stages.

**Cone Funnel Chart** uses a smooth-tapering funnel for the same kind of conversion or process visualisation.

**Pyramid Chart** uses a triangular layout for hierarchical or tiered data.

The example below places a Funnel beside a Cone Funnel with a Pyramid below them, so the three shapes can be compared directly.

#### Progression Chart

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Progression Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/progression-chart/angular/)

## Hierarchical Chart

Hierarchical Chart Widgets show nested part-to-whole relationships, sized by value.

**Treemap Chart** nests rectangles to show a hierarchy of part-to-whole proportions, sized by value.

**Sunburst Chart** uses concentric rings to show the same kind of hierarchy, sized by value.

The example below shows the same hierarchy as both a Treemap and a Sunburst, comparing a rectangular layout against a radial one.

#### Hierarchical Chart

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Hierarchical Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/hierarchical-chart/angular/)

### Hierarchical Chart Setup

Both Widgets share the same Setup panel:

- **Hierarchy Levels** - an ordered list of grouping fields, outermost first. Each level nests inside the one before it.
- **Value** - a numeric field that sizes each tile (Treemap) or segment (Sunburst).

The example below shows sales sized by Net Sales and grouped by Region, then Subcategory.

#### Hierarchical Chart Setup

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Hierarchical Chart Setup](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/hierarchy-chart/angular/)

## Static Content

Static Content Widgets add narrative or supporting material to a report and do not require a data input.

**Text** displays rich text content for titles, descriptions, or annotations, written by the report author rather than bound to a data field.

**Image** displays an image from a URL, for logos, backgrounds, or other visual context, and is likewise not bound to a data field.

The example below shows a Text Widget and an Image Widget placed side by side, neither of them mapped to a field.

#### Static Content

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Static Content](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/static-content/angular/)

## Filter

Filter Widgets give report viewers on-canvas controls for narrowing down the data, without opening the [Filters](https://www.ag-grid.com/studio/archive/3.0.0/angular/filters/) panel.

**Button Filter** shows clickable toggle buttons for quick single or multi-value filtering. It should be used when the list of values is short enough to display as buttons.

**List Filter** shows a scrollable list for selecting one or more values from many options. It should be used when there are too many values to show as buttons.

**Date Filter** shows a date picker for filtering by date range or specific dates.

The example below shows all three Filter Widgets alongside a KPI Widget; selecting a value in any Filter updates the KPI, since it is driven by the combined filter selection.

#### Filter

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Filter](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/filter/angular/)

## Combo

Combo Chart Widgets pair columns with a line series on the same chart, useful when a report needs to show a trend alongside the values that make it up.

**Grouped Column / Line Chart** shows adjacent columns for direct comparison across categories, with a line overlaid to trace a trend across the same categories.

**Stacked Column / Line Chart** shows stacked columns for part-to-whole comparison across categories, with a line overlaid to trace a trend across the same categories.

The columns of either variant can also be split by a Legend field, giving one column series per value in that field while the line stays a single trend across all of them.

The example below shows both Combo Chart variants plotting the same columns and trend line, so the grouped and stacked layouts can be compared.

#### Combo

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Combo](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/combo/angular/)


---
product: "AG Studio"
title: "Widget Catalogue"
description: "Every Widget available in the Widget selector is grouped here exactly as the selector groups them, with a live example and setup options for each group."
framework: vue
version: "3.0.0"
related:
    - title: "Widget Basics"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/widgets/"
    - title: "Building Widgets"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/building-widgets/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Widget Catalogue

Every Widget available in the Widget selector is grouped here exactly as the selector groups them, with a live example and setup options for each group.

See [Widget Basics](https://www.ag-grid.com/studio/archive/3.0.0/vue/widgets/) for how Widgets are created and resized, and [Building Widgets](https://www.ag-grid.com/studio/archive/3.0.0/vue/building-widgets/) for configuring a Widget's data and appearance once it is on the layout.

## Column Chart

Column Chart Widgets use vertical bars to compare values across categories.

**Grouped Column Chart** shows adjacent vertical bars for comparing categories or series side by side. It should be used when comparing individual values matters more than showing how they add up.

**Stacked Column Chart** stacks vertical bars to show part-to-whole relationships across categories. It should be used when both a category's total and its composition matter.

**100% Stacked Column Chart** normalises stacked bars to 100% so segments show proportions rather than absolute values. It should be used when comparing composition across categories matters more than comparing totals.

The example below shows all three Column Chart variants plotted against the same categories, making the shift from absolute values to proportions easy to compare.

#### Column Chart

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "column-chart-grouped": {
              type: "column-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Grouped Column Chart",
                },
              },
            },
            "column-chart-stacked": {
              type: "column-chart-stacked",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Stacked Column Chart",
                },
              },
            },
            "column-chart-stacked-100": {
              type: "column-chart-stacked-100",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "100% Stacked Column Chart",
                },
              },
            },
          },
          widgetLayout: {
            "column-chart-grouped": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "column-chart-stacked": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
            "column-chart-stacked-100": {
              xTrack: 0,
              yTrack: 32,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Column Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/column-chart/vue3/)

## Bar Chart

Bar Chart Widgets use horizontal bars and behave like Column Charts turned on their side, which suits long category labels.

**Grouped Bar Chart** shows adjacent horizontal bars for comparing categories, and works well when category names are long.

**Stacked Bar Chart** stacks horizontal bars to show part-to-whole relationships across categories.

**100% Stacked Bar Chart** normalises stacked horizontal bars to 100% for comparing proportions across categories.

The example below shows the three Bar Chart variants stacked one above the other, plotting the same categories as the Column Chart example.

#### Bar Chart

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "bar-chart-grouped": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Grouped Bar Chart",
                },
              },
            },
            "bar-chart-stacked": {
              type: "bar-chart-stacked",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Stacked Bar Chart",
                },
              },
            },
            "bar-chart-stacked-100": {
              type: "bar-chart-stacked-100",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "100% Stacked Bar Chart",
                },
              },
            },
          },
          widgetLayout: {
            "bar-chart-grouped": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "bar-chart-stacked": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
            "bar-chart-stacked-100": {
              xTrack: 0,
              yTrack: 32,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Bar Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/bar-chart/vue3/)

## Line Chart

The Line Chart group holds a single Widget.

**Line Chart** connects data points with a line to show a trend over time or across a continuous dimension. It should be used when the shape of change matters more than any single value.

The example below shows a Line Chart comparing gold, silver and bronze totals across countries.

#### Line Chart

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "line-chart": {
              type: "line-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Line Chart",
                },
              },
            },
          },
          widgetLayout: {
            "line-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Line Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/line-chart/vue3/)

## Area Chart

Area Chart Widgets fill the area beneath a line, emphasising magnitude alongside trend.

**Area Chart** fills the area beneath a line to emphasise the magnitude of a trend over time.

**Stacked Area Chart** stacks filled areas to show cumulative trends and part-to-whole relationships over time.

**100% Stacked Area Chart** normalises stacked areas to 100% to show proportional trends over time.

The example below shows all three Area Chart variants plotted against the same categories.

#### Area Chart

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "area-chart": {
              type: "area-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Area Chart",
                },
              },
            },
            "area-chart-stacked": {
              type: "area-chart-stacked",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Stacked Area Chart",
                },
              },
            },
            "area-chart-stacked-100": {
              type: "area-chart-stacked-100",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "100% Stacked Area Chart",
                },
              },
            },
          },
          widgetLayout: {
            "area-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "area-chart-stacked": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
            "area-chart-stacked-100": {
              xTrack: 0,
              yTrack: 32,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Area Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/area-chart/vue3/)

## Value

The Value group covers Widgets that spotlight a single aggregated number.

**KPI** displays a single aggregated number prominently. It should be used for totals and headline metrics that need no visual comparison.

**Radial Gauge** shows a value against a defined range on a circular dial. It should be used for progress or target tracking.

**Linear Gauge** shows a value against a range on a horizontal or vertical bar. It should be used for progress or threshold indicators.

The example below shows a KPI alongside both gauge types tracking the same underlying value.

#### Value

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            value: {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "KPI",
                },
              },
            },
            "radial-gauge": {
              type: "radial-gauge",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Radial Gauge",
                },
              },
            },
            "linear-gauge": {
              type: "linear-gauge",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Linear Gauge",
                },
              },
            },
          },
          widgetLayout: {
            value: {
              xTrack: 0,
              yTrack: 0,
              xSpan: 8,
              ySpan: 12,
            },
            "radial-gauge": {
              xTrack: 8,
              yTrack: 0,
              xSpan: 8,
              ySpan: 12,
            },
            "linear-gauge": {
              xTrack: 16,
              yTrack: 0,
              xSpan: 8,
              ySpan: 12,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Value](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/value/vue3/)

## Scatter Chart

Scatter Chart Widgets plot individual data points across two axes to reveal correlations.

**Scatter Chart** plots dots on two axes to compare grouped data and show correlations.

**Bubble Chart** extends a scatter plot with variable dot sizes, adding a third data dimension.

The example below shows a Scatter Chart above a Bubble Chart using the same two axes, with the Bubble Chart adding size as a third dimension.

#### Scatter Chart

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "scatter-chart": {
              type: "scatter-chart",
              dataMapping: {
                groupByKey: [{ id: "medals.country" }],
                categoryKey: [{ id: "medals.gold", aggregation: "sum" }],
                valueKey: [{ id: "medals.silver", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Scatter Chart",
                },
              },
            },
            "bubble-chart": {
              type: "bubble-chart",
              dataMapping: {
                groupByKey: [{ id: "medals.country" }],
                sizeKey: [{ id: "medals.total", aggregation: "sum" }],
                categoryKey: [{ id: "medals.gold", aggregation: "sum" }],
                valueKey: [{ id: "medals.silver", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Bubble Chart",
                },
              },
            },
          },
          widgetLayout: {
            "scatter-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "bubble-chart": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Scatter Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/scatter-chart/vue3/)

## Table

This group holds the two Widgets for displaying data in rows and columns.

**Table** lists rows and columns with sortable and filterable headers. It should be used for row-level exploration of detailed data.

**Pivot Table** groups and pivots data across row and column axes. It should be used for hierarchical drill-down and cross-tabulated summaries.

The example below shows a flat list of rows above a pivoted view of the same data.

#### Table

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            grid: {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "medals.country" },
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Table",
                },
              },
            },
            "pivot-grid": {
              type: "pivot-grid",
              dataMapping: {
                rows: [{ id: "medals.country" }],
                columns: [{ id: "medals.year" }],
                values: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Pivot Table",
                },
              },
            },
          },
          widgetLayout: {
            grid: {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "pivot-grid": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Table](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/table/vue3/)

### Pivot Table Setup

A Pivot Table summarises a measure across a row axis and, optionally, a column axis. Its Setup panel has three data slots:

- **Rows** - grouping fields, outer to inner. Each field adds a level of row grouping.
- **Columns** - optional grouping fields, outer to inner. Adding a field here pivots the Values onto a column axis instead of listing them as flat columns.
- **Values** - one or more measures, aggregated for each row (and, once pivoted, for each row-column cell).

Row groups start expanded when no field is mapped to Columns, and collapsed once one is. Click a row to expand or collapse it; expanding loads its child rows. Column groups always start collapsed - click to expand them.

#### Pivot Table

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "sales-pivot": {
              type: "pivot-grid",
              dataMapping: {
                rows: [{ id: "stores.region" }, { id: "products.subcategory" }],
                columns: [{ id: "orders.channel" }],
                values: [{ id: "net_sales" }, { id: "gross_sales" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales and Gross Sales by Region, Category, and Channel",
                },
              },
              sort: [
                { field: { id: "products.subcategory" }, direction: "asc" },
              ],
            },
          },
          widgetLayout: {
            "sales-pivot": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 41 },
          },
          selection: { type: "widget", id: "sales-pivot" },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["edit"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(
      getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
    );

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Pivot Table](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/pivot-table/vue3/)

### Totals

Two independent totals are available on the Pivot Table's Format tab, both off by default:

- **Total Row** - a grand total pinned as the last row, summing every measure across the whole table.
- **Total Columns** - available once a field is mapped to Columns. Adds a column summing each measure across every column member. Set **Placement** to **Beginning** or **End**.

### Empty Cells

A Pivot Table holds a cell for every combination of row and column member, but the data rarely fills all of them. Where a combination has no rows behind it there is nothing to aggregate, so the cell shows `N/A` instead of a number. A cell showing `0` means the opposite: rows exist for that combination, and the measure adds up to zero across them.

Both appear in the medals example at the top of this section. Its data covers Summer and Winter Games in alternating years, and most countries win in one or the other. A country that competes only in summer shows `N/A` across the winter years. A country that won that year but took no gold shows `0` in its Gold column.

## Polar Chart

The Polar Chart group brings together the radar and radial Widgets, which plot values around a circular axis rather than a linear one.

**Radar Line Chart** uses lines on a radar layout to compare multiple variables at once.

**Radar Area Chart** fills the area on a radar layout to emphasise coverage across dimensions.

**Radial Column Chart** arranges bars in a circle. It should be used for cyclical or categorical data.

**Nightingale Chart** uses sectors of varying radius to emphasise differences in value.

**Radial Bar Chart** uses concentric circular bars for compact category comparisons.

The example below shows all five Polar Chart Widgets plotting the same categories, so the different circular layouts can be compared directly.

#### Polar Chart

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "radar-line-chart": {
              type: "radar-line-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Radar Line Chart",
                },
              },
            },
            "radar-area-chart": {
              type: "radar-area-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Radar Area Chart",
                },
              },
            },
            "radial-column-chart": {
              type: "radial-column-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Radial Column Chart",
                },
              },
            },
            "nightingale-chart": {
              type: "nightingale-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Nightingale Chart",
                },
              },
            },
            "radial-bar-chart": {
              type: "radial-bar-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Radial Bar Chart",
                },
              },
            },
          },
          widgetLayout: {
            "radar-line-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 12,
              ySpan: 20,
            },
            "radar-area-chart": {
              xTrack: 12,
              yTrack: 0,
              xSpan: 12,
              ySpan: 20,
            },
            "radial-column-chart": {
              xTrack: 0,
              yTrack: 20,
              xSpan: 12,
              ySpan: 20,
            },
            "radial-bar-chart": {
              xTrack: 12,
              yTrack: 20,
              xSpan: 12,
              ySpan: 20,
            },
            "nightingale-chart": {
              xTrack: 6,
              yTrack: 40,
              xSpan: 12,
              ySpan: 20,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Polar Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/polar-chart/vue3/)

## Proportional Chart

Proportional Chart Widgets show how a whole splits into parts.

**Pie Chart** divides a circle into slices to show simple part-to-whole proportions.

**Donut Chart** is a Pie Chart with a hollow centre, leaving room for a central metric or label.

The example below places a Pie Chart beside a Donut Chart splitting the same values, so the hollow centre is the only difference between them.

#### Proportional Chart

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "pie-chart": {
              type: "pie-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Pie Chart",
                },
              },
            },
            "donut-chart": {
              type: "donut-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Donut Chart",
                },
              },
            },
          },
          widgetLayout: {
            "pie-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 12,
              ySpan: 20,
            },
            "donut-chart": {
              xTrack: 12,
              yTrack: 0,
              xSpan: 12,
              ySpan: 20,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Proportional Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/proportional-chart/vue3/)

## Progression Chart

Progression Chart Widgets show values narrowing through sequential stages, such as a sales or conversion funnel.

**Funnel Chart** uses a stepped funnel to show conversion rates or sequential process stages.

**Cone Funnel Chart** uses a smooth-tapering funnel for the same kind of conversion or process visualisation.

**Pyramid Chart** uses a triangular layout for hierarchical or tiered data.

The example below places a Funnel beside a Cone Funnel with a Pyramid below them, so the three shapes can be compared directly.

#### Progression Chart

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "funnel-chart": {
              type: "funnel-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [{ id: "medals.gold", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Funnel Chart",
                },
              },
            },
            "cone-funnel-chart": {
              type: "cone-funnel-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [{ id: "medals.gold", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Cone Funnel Chart",
                },
              },
            },
            "pyramid-chart": {
              type: "pyramid-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [{ id: "medals.gold", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Pyramid Chart",
                },
              },
            },
          },
          widgetLayout: {
            "funnel-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 12,
              ySpan: 16,
            },
            "cone-funnel-chart": {
              xTrack: 12,
              yTrack: 0,
              xSpan: 12,
              ySpan: 16,
            },
            "pyramid-chart": {
              xTrack: 6,
              yTrack: 16,
              xSpan: 12,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Progression Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/progression-chart/vue3/)

## Hierarchical Chart

Hierarchical Chart Widgets show nested part-to-whole relationships, sized by value.

**Treemap Chart** nests rectangles to show a hierarchy of part-to-whole proportions, sized by value.

**Sunburst Chart** uses concentric rings to show the same kind of hierarchy, sized by value.

The example below shows the same hierarchy as both a Treemap and a Sunburst, comparing a rectangular layout against a radial one.

#### Hierarchical Chart

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "treemap-chart": {
              type: "treemap-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }, { id: "medals.sport" }],
                valueKey: [{ id: "medals.gold", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Treemap Chart",
                },
              },
            },
            "sunburst-chart": {
              type: "sunburst-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }, { id: "medals.sport" }],
                valueKey: [{ id: "medals.gold", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Sunburst Chart",
                },
              },
            },
          },
          widgetLayout: {
            "treemap-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "sunburst-chart": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Hierarchical Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/hierarchical-chart/vue3/)

### Hierarchical Chart Setup

Both Widgets share the same Setup panel:

- **Hierarchy Levels** - an ordered list of grouping fields, outermost first. Each level nests inside the one before it.
- **Value** - a numeric field that sizes each tile (Treemap) or segment (Sunburst).

The example below shows sales sized by Net Sales and grouped by Region, then Subcategory.

#### Hierarchical Chart Setup

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "sales-treemap": {
              type: "treemap-chart",
              dataMapping: {
                categoryKey: [
                  { id: "stores.region" },
                  { id: "products.subcategory" },
                ],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales by Region and Subcategory",
                },
              },
              sort: [
                { field: { id: "products.subcategory" }, direction: "asc" },
              ],
            },
          },
          widgetLayout: {
            "sales-treemap": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 32,
            },
          },
          selection: { type: "widget", id: "sales-treemap" },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["edit"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(
      getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
    );

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Hierarchical Chart Setup](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/hierarchy-chart/vue3/)

## Static Content

Static Content Widgets add narrative or supporting material to a report and do not require a data input.

**Text** displays rich text content for titles, descriptions, or annotations, written by the report author rather than bound to a data field.

**Image** displays an image from a URL, for logos, backgrounds, or other visual context, and is likewise not bound to a data field.

The example below shows a Text Widget and an Image Widget placed side by side, neither of them mapped to a field.

#### Static Content

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            text: {
              type: "text",
              dataMapping: {},
              format: {
                title: {
                  enabled: true,
                  text: "Text",
                },
                style: {
                  text: "The Text Widget shows static content such as a heading, a note or an explanation. It is not bound to a data field.",
                },
              },
            },
            image: {
              type: "image",
              dataMapping: {},
              format: {
                title: {
                  enabled: true,
                  text: "Image",
                },
                style: {
                  src: "https://www.ag-grid.com/studio/images/ag-studio-logo.svg",
                  objectFit: "contain",
                },
              },
            },
          },
          widgetLayout: {
            text: {
              xTrack: 0,
              yTrack: 0,
              xSpan: 12,
              ySpan: 16,
            },
            image: {
              xTrack: 12,
              yTrack: 0,
              xSpan: 12,
              ySpan: 16,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Static Content](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/static-content/vue3/)

## Filter

Filter Widgets give report viewers on-canvas controls for narrowing down the data, without opening the [Filters](https://www.ag-grid.com/studio/archive/3.0.0/vue/filters/) panel.

**Button Filter** shows clickable toggle buttons for quick single or multi-value filtering. It should be used when the list of values is short enough to display as buttons.

**List Filter** shows a scrollable list for selecting one or more values from many options. It should be used when there are too many values to show as buttons.

**Date Filter** shows a date picker for filtering by date range or specific dates.

The example below shows all three Filter Widgets alongside a KPI Widget; selecting a value in any Filter updates the KPI, since it is driven by the combined filter selection.

#### Filter

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "button-filter": {
              type: "button-filter",
              dataMapping: {
                value: [{ id: "medals.country" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Button Filter",
                },
              },
            },
            "list-filter": {
              type: "list-filter",
              dataMapping: {
                value: [{ id: "medals.sport" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "List Filter",
                },
              },
            },
            "date-filter": {
              type: "date-filter",
              dataMapping: {
                value: [{ id: "medals.date" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Date Filter",
                },
              },
            },
            value: {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Total Gold Medals",
                },
              },
            },
          },
          widgetLayout: {
            "button-filter": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 8,
              ySpan: 16,
            },
            "list-filter": {
              xTrack: 8,
              yTrack: 0,
              xSpan: 8,
              ySpan: 16,
            },
            "date-filter": {
              xTrack: 16,
              yTrack: 0,
              xSpan: 8,
              ySpan: 16,
            },
            value: {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 8,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Filter](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/filter/vue3/)

## Combo

Combo Chart Widgets pair columns with a line series on the same chart, useful when a report needs to show a trend alongside the values that make it up.

**Grouped Column / Line Chart** shows adjacent columns for direct comparison across categories, with a line overlaid to trace a trend across the same categories.

**Stacked Column / Line Chart** shows stacked columns for part-to-whole comparison across categories, with a line overlaid to trace a trend across the same categories.

The columns of either variant can also be split by a Legend field, giving one column series per value in that field while the line stays a single trend across all of them.

The example below shows both Combo Chart variants plotting the same columns and trend line, so the grouped and stacked layouts can be compared.

#### Combo

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "page1",
          widgets: {
            "combo-chart-grouped-column-line": {
              type: "combo-chart-grouped-column-line",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                secondaryValueKey: [{ id: "medals.total", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Grouped Column / Line Chart",
                },
              },
            },
            "combo-chart-stacked-column-line": {
              type: "combo-chart-stacked-column-line",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                secondaryValueKey: [{ id: "medals.total", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Stacked Column / Line Chart",
                },
              },
            },
          },
          widgetLayout: {
            "combo-chart-grouped-column-line": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "combo-chart-stacked-column-line": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Combo](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/combo/vue3/)


---
product: "AG Studio"
title: "Widget Catalogue"
description: "Every Widget available in the Widget selector is grouped here exactly as the selector groups them, with a live example and setup options for each group."
framework: react
version: "3.0.0"
related:
    - title: "Widget Basics"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/widgets/"
    - title: "Building Widgets"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/building-widgets/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# Widget Catalogue

Every Widget available in the Widget selector is grouped here exactly as the selector groups them, with a live example and setup options for each group.

See [Widget Basics](https://www.ag-grid.com/studio/archive/3.0.0/react/widgets/) for how Widgets are created and resized, and [Building Widgets](https://www.ag-grid.com/studio/archive/3.0.0/react/building-widgets/) for configuring a Widget's data and appearance once it is on the layout.

## Column Chart

Column Chart Widgets use vertical bars to compare values across categories.

**Grouped Column Chart** shows adjacent vertical bars for comparing categories or series side by side. It should be used when comparing individual values matters more than showing how they add up.

**Stacked Column Chart** stacks vertical bars to show part-to-whole relationships across categories. It should be used when both a category's total and its composition matter.

**100% Stacked Column Chart** normalises stacked bars to 100% so segments show proportions rather than absolute values. It should be used when comparing composition across categories matters more than comparing totals.

The example below shows all three Column Chart variants plotted against the same categories, making the shift from absolute values to proportions easy to compare.

#### Column Chart

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "column-chart-grouped": {
              type: "column-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Grouped Column Chart",
                },
              },
            },
            "column-chart-stacked": {
              type: "column-chart-stacked",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Stacked Column Chart",
                },
              },
            },
            "column-chart-stacked-100": {
              type: "column-chart-stacked-100",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "100% Stacked Column Chart",
                },
              },
            },
          },
          widgetLayout: {
            "column-chart-grouped": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "column-chart-stacked": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
            "column-chart-stacked-100": {
              xTrack: 0,
              yTrack: 32,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Column Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/column-chart/reactFunctionalTs/)

## Bar Chart

Bar Chart Widgets use horizontal bars and behave like Column Charts turned on their side, which suits long category labels.

**Grouped Bar Chart** shows adjacent horizontal bars for comparing categories, and works well when category names are long.

**Stacked Bar Chart** stacks horizontal bars to show part-to-whole relationships across categories.

**100% Stacked Bar Chart** normalises stacked horizontal bars to 100% for comparing proportions across categories.

The example below shows the three Bar Chart variants stacked one above the other, plotting the same categories as the Column Chart example.

#### Bar Chart

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "bar-chart-grouped": {
              type: "bar-chart-grouped",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Grouped Bar Chart",
                },
              },
            },
            "bar-chart-stacked": {
              type: "bar-chart-stacked",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Stacked Bar Chart",
                },
              },
            },
            "bar-chart-stacked-100": {
              type: "bar-chart-stacked-100",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "100% Stacked Bar Chart",
                },
              },
            },
          },
          widgetLayout: {
            "bar-chart-grouped": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "bar-chart-stacked": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
            "bar-chart-stacked-100": {
              xTrack: 0,
              yTrack: 32,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Bar Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/bar-chart/reactFunctionalTs/)

## Line Chart

The Line Chart group holds a single Widget.

**Line Chart** connects data points with a line to show a trend over time or across a continuous dimension. It should be used when the shape of change matters more than any single value.

The example below shows a Line Chart comparing gold, silver and bronze totals across countries.

#### Line Chart

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "line-chart": {
              type: "line-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Line Chart",
                },
              },
            },
          },
          widgetLayout: {
            "line-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Line Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/line-chart/reactFunctionalTs/)

## Area Chart

Area Chart Widgets fill the area beneath a line, emphasising magnitude alongside trend.

**Area Chart** fills the area beneath a line to emphasise the magnitude of a trend over time.

**Stacked Area Chart** stacks filled areas to show cumulative trends and part-to-whole relationships over time.

**100% Stacked Area Chart** normalises stacked areas to 100% to show proportional trends over time.

The example below shows all three Area Chart variants plotted against the same categories.

#### Area Chart

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "area-chart": {
              type: "area-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Area Chart",
                },
              },
            },
            "area-chart-stacked": {
              type: "area-chart-stacked",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Stacked Area Chart",
                },
              },
            },
            "area-chart-stacked-100": {
              type: "area-chart-stacked-100",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "100% Stacked Area Chart",
                },
              },
            },
          },
          widgetLayout: {
            "area-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "area-chart-stacked": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
            "area-chart-stacked-100": {
              xTrack: 0,
              yTrack: 32,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Area Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/area-chart/reactFunctionalTs/)

## Value

The Value group covers Widgets that spotlight a single aggregated number.

**KPI** displays a single aggregated number prominently. It should be used for totals and headline metrics that need no visual comparison.

**Radial Gauge** shows a value against a defined range on a circular dial. It should be used for progress or target tracking.

**Linear Gauge** shows a value against a range on a horizontal or vertical bar. It should be used for progress or threshold indicators.

The example below shows a KPI alongside both gauge types tracking the same underlying value.

#### Value

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            value: {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "KPI",
                },
              },
            },
            "radial-gauge": {
              type: "radial-gauge",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Radial Gauge",
                },
              },
            },
            "linear-gauge": {
              type: "linear-gauge",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Linear Gauge",
                },
              },
            },
          },
          widgetLayout: {
            value: {
              xTrack: 0,
              yTrack: 0,
              xSpan: 8,
              ySpan: 12,
            },
            "radial-gauge": {
              xTrack: 8,
              yTrack: 0,
              xSpan: 8,
              ySpan: 12,
            },
            "linear-gauge": {
              xTrack: 16,
              yTrack: 0,
              xSpan: 8,
              ySpan: 12,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Value](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/value/reactFunctionalTs/)

## Scatter Chart

Scatter Chart Widgets plot individual data points across two axes to reveal correlations.

**Scatter Chart** plots dots on two axes to compare grouped data and show correlations.

**Bubble Chart** extends a scatter plot with variable dot sizes, adding a third data dimension.

The example below shows a Scatter Chart above a Bubble Chart using the same two axes, with the Bubble Chart adding size as a third dimension.

#### Scatter Chart

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "scatter-chart": {
              type: "scatter-chart",
              dataMapping: {
                groupByKey: [{ id: "medals.country" }],
                categoryKey: [{ id: "medals.gold", aggregation: "sum" }],
                valueKey: [{ id: "medals.silver", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Scatter Chart",
                },
              },
            },
            "bubble-chart": {
              type: "bubble-chart",
              dataMapping: {
                groupByKey: [{ id: "medals.country" }],
                sizeKey: [{ id: "medals.total", aggregation: "sum" }],
                categoryKey: [{ id: "medals.gold", aggregation: "sum" }],
                valueKey: [{ id: "medals.silver", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Bubble Chart",
                },
              },
            },
          },
          widgetLayout: {
            "scatter-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "bubble-chart": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Scatter Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/scatter-chart/reactFunctionalTs/)

## Table

This group holds the two Widgets for displaying data in rows and columns.

**Table** lists rows and columns with sortable and filterable headers. It should be used for row-level exploration of detailed data.

**Pivot Table** groups and pivots data across row and column axes. It should be used for hierarchical drill-down and cross-tabulated summaries.

The example below shows a flat list of rows above a pivoted view of the same data.

#### Table

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            grid: {
              type: "grid",
              dataMapping: {
                cols: [
                  { id: "medals.country" },
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Table",
                },
              },
            },
            "pivot-grid": {
              type: "pivot-grid",
              dataMapping: {
                rows: [{ id: "medals.country" }],
                columns: [{ id: "medals.year" }],
                values: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Pivot Table",
                },
              },
            },
          },
          widgetLayout: {
            grid: {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "pivot-grid": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Table](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/table/reactFunctionalTs/)

### Pivot Table Setup

A Pivot Table summarises a measure across a row axis and, optionally, a column axis. Its Setup panel has three data slots:

- **Rows** - grouping fields, outer to inner. Each field adds a level of row grouping.
- **Columns** - optional grouping fields, outer to inner. Adding a field here pivots the Values onto a column axis instead of listing them as flat columns.
- **Values** - one or more measures, aggregated for each row (and, once pivoted, for each row-column cell).

Row groups start expanded when no field is mapped to Columns, and collapsed once one is. Click a row to expand or collapse it; expanding loads its child rows. Column groups always start collapsed - click to expand them.

#### Pivot Table

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(
    getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
  );
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "sales-pivot": {
              type: "pivot-grid",
              dataMapping: {
                rows: [{ id: "stores.region" }, { id: "products.subcategory" }],
                columns: [{ id: "orders.channel" }],
                values: [{ id: "net_sales" }, { id: "gross_sales" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales and Gross Sales by Region, Category, and Channel",
                },
              },
              sort: [
                { field: { id: "products.subcategory" }, direction: "asc" },
              ],
            },
          },
          widgetLayout: {
            "sales-pivot": { xTrack: 0, yTrack: 0, xSpan: 24, ySpan: 41 },
          },
          selection: { type: "widget", id: "sales-pivot" },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["edit"],
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Pivot Table](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/pivot-table/reactFunctionalTs/)

### Totals

Two independent totals are available on the Pivot Table's Format tab, both off by default:

- **Total Row** - a grand total pinned as the last row, summing every measure across the whole table.
- **Total Columns** - available once a field is mapped to Columns. Adds a column summing each measure across every column member. Set **Placement** to **Beginning** or **End**.

### Empty Cells

A Pivot Table holds a cell for every combination of row and column member, but the data rarely fills all of them. Where a combination has no rows behind it there is nothing to aggregate, so the cell shows `N/A` instead of a number. A cell showing `0` means the opposite: rows exist for that combination, and the measure adds up to zero across them.

Both appear in the medals example at the top of this section. Its data covers Summer and Winter Games in alternating years, and most countries win in one or the other. A country that competes only in summer shows `N/A` across the winter years. A country that won that year but took no gold shows `0` in its Gold column.

## Polar Chart

The Polar Chart group brings together the radar and radial Widgets, which plot values around a circular axis rather than a linear one.

**Radar Line Chart** uses lines on a radar layout to compare multiple variables at once.

**Radar Area Chart** fills the area on a radar layout to emphasise coverage across dimensions.

**Radial Column Chart** arranges bars in a circle. It should be used for cyclical or categorical data.

**Nightingale Chart** uses sectors of varying radius to emphasise differences in value.

**Radial Bar Chart** uses concentric circular bars for compact category comparisons.

The example below shows all five Polar Chart Widgets plotting the same categories, so the different circular layouts can be compared directly.

#### Polar Chart

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "radar-line-chart": {
              type: "radar-line-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Radar Line Chart",
                },
              },
            },
            "radar-area-chart": {
              type: "radar-area-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Radar Area Chart",
                },
              },
            },
            "radial-column-chart": {
              type: "radial-column-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Radial Column Chart",
                },
              },
            },
            "nightingale-chart": {
              type: "nightingale-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Nightingale Chart",
                },
              },
            },
            "radial-bar-chart": {
              type: "radial-bar-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Radial Bar Chart",
                },
              },
            },
          },
          widgetLayout: {
            "radar-line-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 12,
              ySpan: 20,
            },
            "radar-area-chart": {
              xTrack: 12,
              yTrack: 0,
              xSpan: 12,
              ySpan: 20,
            },
            "radial-column-chart": {
              xTrack: 0,
              yTrack: 20,
              xSpan: 12,
              ySpan: 20,
            },
            "radial-bar-chart": {
              xTrack: 12,
              yTrack: 20,
              xSpan: 12,
              ySpan: 20,
            },
            "nightingale-chart": {
              xTrack: 6,
              yTrack: 40,
              xSpan: 12,
              ySpan: 20,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Polar Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/polar-chart/reactFunctionalTs/)

## Proportional Chart

Proportional Chart Widgets show how a whole splits into parts.

**Pie Chart** divides a circle into slices to show simple part-to-whole proportions.

**Donut Chart** is a Pie Chart with a hollow centre, leaving room for a central metric or label.

The example below places a Pie Chart beside a Donut Chart splitting the same values, so the hollow centre is the only difference between them.

#### Proportional Chart

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "pie-chart": {
              type: "pie-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Pie Chart",
                },
              },
            },
            "donut-chart": {
              type: "donut-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Donut Chart",
                },
              },
            },
          },
          widgetLayout: {
            "pie-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 12,
              ySpan: 20,
            },
            "donut-chart": {
              xTrack: 12,
              yTrack: 0,
              xSpan: 12,
              ySpan: 20,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Proportional Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/proportional-chart/reactFunctionalTs/)

## Progression Chart

Progression Chart Widgets show values narrowing through sequential stages, such as a sales or conversion funnel.

**Funnel Chart** uses a stepped funnel to show conversion rates or sequential process stages.

**Cone Funnel Chart** uses a smooth-tapering funnel for the same kind of conversion or process visualisation.

**Pyramid Chart** uses a triangular layout for hierarchical or tiered data.

The example below places a Funnel beside a Cone Funnel with a Pyramid below them, so the three shapes can be compared directly.

#### Progression Chart

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "funnel-chart": {
              type: "funnel-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [{ id: "medals.gold", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Funnel Chart",
                },
              },
            },
            "cone-funnel-chart": {
              type: "cone-funnel-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [{ id: "medals.gold", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Cone Funnel Chart",
                },
              },
            },
            "pyramid-chart": {
              type: "pyramid-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [{ id: "medals.gold", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Pyramid Chart",
                },
              },
            },
          },
          widgetLayout: {
            "funnel-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 12,
              ySpan: 16,
            },
            "cone-funnel-chart": {
              xTrack: 12,
              yTrack: 0,
              xSpan: 12,
              ySpan: 16,
            },
            "pyramid-chart": {
              xTrack: 6,
              yTrack: 16,
              xSpan: 12,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Progression Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/progression-chart/reactFunctionalTs/)

## Hierarchical Chart

Hierarchical Chart Widgets show nested part-to-whole relationships, sized by value.

**Treemap Chart** nests rectangles to show a hierarchy of part-to-whole proportions, sized by value.

**Sunburst Chart** uses concentric rings to show the same kind of hierarchy, sized by value.

The example below shows the same hierarchy as both a Treemap and a Sunburst, comparing a rectangular layout against a radial one.

#### Hierarchical Chart

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "treemap-chart": {
              type: "treemap-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }, { id: "medals.sport" }],
                valueKey: [{ id: "medals.gold", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Treemap Chart",
                },
              },
            },
            "sunburst-chart": {
              type: "sunburst-chart",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }, { id: "medals.sport" }],
                valueKey: [{ id: "medals.gold", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Sunburst Chart",
                },
              },
            },
          },
          widgetLayout: {
            "treemap-chart": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "sunburst-chart": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Hierarchical Chart](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/hierarchical-chart/reactFunctionalTs/)

### Hierarchical Chart Setup

Both Widgets share the same Setup panel:

- **Hierarchy Levels** - an ordered list of grouping fields, outermost first. Each level nests inside the one before it.
- **Value** - a numeric field that sizes each tile (Treemap) or segment (Sunburst).

The example below shows sales sized by Net Sales and grouped by Region, then Subcategory.

#### Hierarchical Chart Setup

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSource>(
    getMainDemoData("https://www.ag-grid.com/studio/archive/3.0.0/example-assets"),
  );
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "sales-treemap": {
              type: "treemap-chart",
              dataMapping: {
                categoryKey: [
                  { id: "stores.region" },
                  { id: "products.subcategory" },
                ],
                valueKey: [{ id: "net_sales" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Net Sales by Region and Subcategory",
                },
              },
              sort: [
                { field: { id: "products.subcategory" }, direction: "asc" },
              ],
            },
          },
          widgetLayout: {
            "sales-treemap": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 32,
            },
          },
          selection: { type: "widget", id: "sales-treemap" },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["edit"],
      },
    };
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Hierarchical Chart Setup](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/hierarchy-chart/reactFunctionalTs/)

## Static Content

Static Content Widgets add narrative or supporting material to a report and do not require a data input.

**Text** displays rich text content for titles, descriptions, or annotations, written by the report author rather than bound to a data field.

**Image** displays an image from a URL, for logos, backgrounds, or other visual context, and is likewise not bound to a data field.

The example below shows a Text Widget and an Image Widget placed side by side, neither of them mapped to a field.

#### Static Content

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            text: {
              type: "text",
              dataMapping: {},
              format: {
                title: {
                  enabled: true,
                  text: "Text",
                },
                style: {
                  text: "The Text Widget shows static content such as a heading, a note or an explanation. It is not bound to a data field.",
                },
              },
            },
            image: {
              type: "image",
              dataMapping: {},
              format: {
                title: {
                  enabled: true,
                  text: "Image",
                },
                style: {
                  src: "https://www.ag-grid.com/studio/images/ag-studio-logo.svg",
                  objectFit: "contain",
                },
              },
            },
          },
          widgetLayout: {
            text: {
              xTrack: 0,
              yTrack: 0,
              xSpan: 12,
              ySpan: 16,
            },
            image: {
              xTrack: 12,
              yTrack: 0,
              xSpan: 12,
              ySpan: 16,
            },
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Static Content](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/static-content/reactFunctionalTs/)

## Filter

Filter Widgets give report viewers on-canvas controls for narrowing down the data, without opening the [Filters](https://www.ag-grid.com/studio/archive/3.0.0/react/filters/) panel.

**Button Filter** shows clickable toggle buttons for quick single or multi-value filtering. It should be used when the list of values is short enough to display as buttons.

**List Filter** shows a scrollable list for selecting one or more values from many options. It should be used when there are too many values to show as buttons.

**Date Filter** shows a date picker for filtering by date range or specific dates.

The example below shows all three Filter Widgets alongside a KPI Widget; selecting a value in any Filter updates the KPI, since it is driven by the combined filter selection.

#### Filter

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "button-filter": {
              type: "button-filter",
              dataMapping: {
                value: [{ id: "medals.country" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Button Filter",
                },
              },
            },
            "list-filter": {
              type: "list-filter",
              dataMapping: {
                value: [{ id: "medals.sport" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "List Filter",
                },
              },
            },
            "date-filter": {
              type: "date-filter",
              dataMapping: {
                value: [{ id: "medals.date" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Date Filter",
                },
              },
            },
            value: {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.gold", aggregation: "sum" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Total Gold Medals",
                },
              },
            },
          },
          widgetLayout: {
            "button-filter": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 8,
              ySpan: 16,
            },
            "list-filter": {
              xTrack: 8,
              yTrack: 0,
              xSpan: 8,
              ySpan: 16,
            },
            "date-filter": {
              xTrack: 16,
              yTrack: 0,
              xSpan: 8,
              ySpan: 16,
            },
            value: {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 8,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Filter](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/filter/reactFunctionalTs/)

## Combo

Combo Chart Widgets pair columns with a line series on the same chart, useful when a report needs to show a trend alongside the values that make it up.

**Grouped Column / Line Chart** shows adjacent columns for direct comparison across categories, with a line overlaid to trace a trend across the same categories.

**Stacked Column / Line Chart** shows stacked columns for part-to-whole comparison across categories, with a line overlaid to trace a trend across the same categories.

The columns of either variant can also be split by a Legend field, giving one column series per value in that field while the line stays a single trend across all of them.

The example below shows both Combo Chart variants plotting the same columns and trend line, so the grouped and stacked layouts can be compared.

#### Combo

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "page1",
          widgets: {
            "combo-chart-grouped-column-line": {
              type: "combo-chart-grouped-column-line",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                secondaryValueKey: [{ id: "medals.total", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Grouped Column / Line Chart",
                },
              },
            },
            "combo-chart-stacked-column-line": {
              type: "combo-chart-stacked-column-line",
              dataMapping: {
                categoryKey: [{ id: "medals.country" }],
                valueKey: [
                  { id: "medals.gold", aggregation: "sum" },
                  { id: "medals.silver", aggregation: "sum" },
                  { id: "medals.bronze", aggregation: "sum" },
                ],
                secondaryValueKey: [{ id: "medals.total", aggregation: "sum" }],
                tooltipKey: [],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Stacked Column / Line Chart",
                },
              },
            },
          },
          widgetLayout: {
            "combo-chart-grouped-column-line": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 24,
              ySpan: 16,
            },
            "combo-chart-stacked-column-line": {
              xTrack: 0,
              yTrack: 16,
              xSpan: 24,
              ySpan: 16,
            },
          },
          filter: {
            page: [
              {
                field: { id: "medals.total" },
                model: {
                  operator: "greaterThan",
                  value: 3,
                },
              },
            ],
          },
        },
      ],
      selectedPageId: "page1",
      panels: {
        filters: {
          collapsed: true,
        },
        data: {
          collapsed: true,
        },
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Combo](https://www.ag-grid.com/studio/archive/3.0.0/examples/widget-catalogue/combo/reactFunctionalTs/)
